@REM Laszlo Frazer 2019
@REM 
@REM If you get an error like this:
@REM Assertion failed: ==RAND_MAX, file ran1.c, line 2
@REM Your compiler uses a different value of RAND_MAX
@REM You can edit the assertion in ran1.c or use a 
@REM better compiler.  A larger RAND_MAX
@REM will get you more accurate results.
@REM Windows compilers have a poor RAND_MAX.

@echo Use this window for debugging.

@REM Get input
zenity --forms \^
 --text="Configure Upconversion Simulation" ^
 --add-entry="Simulation depth bins" ^
 --add-entry="Depth of anabathmophore (cm)" ^
 --add-entry="Triplet decay rate k1 (per second)" ^
 --add-entry="Triplet annihilation rate k2 (cm^3 per second)" ^
 --add-entry="Yield eta" ^
 --add-entry="Sensitizer concentration (M)" ^
 --add-entry="Emitter concentration (M)" ^
 --add-entry="Solar concentration (suns)" ^
 --add-entry="Bandgap (nm)" ^
 --add-entry="Solar cell absorption parameter" ^
 --add-entry="Difference in triplet energy levels (eV)" ^
 --add-entry="Temperature (K)" ^
 --title "Upconversion" ^
 > generator.txt

@REM Reformat
fnr.exe --cl --dir %cd% --fileMask "generator.txt" --includeSubDirectories --find "|" --replace " "

@REM Does not check if you have selected a file or clicked cancel.
@REM Files may not exist.

for /F "delims=" %%L in ('zenity --file-selection --title="Select Sensitizer Absorption File"') do (set "VAR=%%L")
copy %VAR% absorption.txt
for /F "delims=" %%L in ('zenity --file-selection --title="Select Emitter Absorption File"') do (set "VAR=%%L")
copy %VAR% emitter_absorption.txt
for /F "delims=" %%L in ('zenity --file-selection --title="Select Emitter Emission File"') do (set "VAR=%%L")
copy %VAR% emission.txt
for /F "delims=" %%L in ('zenity --file-selection --title="Select Illumination File"') do (set "VAR=%%L")
copy %VAR% spectrum.txt

set /p generator=<generator.txt
start /b zenity --info --text='Calculation starting.  The time is %time%.' --title "Starting" --width=600

@REM start calculation
for /F "delims=" %%L in ('a.exe %generator%') do (set "VAR=%%L")

@REM Display result
zenity --info --text='%VAR% The time is %time%.' --title "Calculated Result (mA/cm^2)" --width=600

exit
